#include "ArithmeticCompressionTest.h"

#include <stringology/compression/ArithmeticCompression.h>
#include <stringology/compression/ArithmeticDecompression.h>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( ArithmeticCompressionTest, "compression" );
CPPUNIT_TEST_SUITE_REGISTRATION( ArithmeticCompressionTest );

void ArithmeticCompressionTest::setUp() {
}

void ArithmeticCompressionTest::tearDown() {
}

void ArithmeticCompressionTest::basics() {
	ext::string rawInput ( "abbabbabaae123456789r0 8723 babababb  ab bapobababbbabaaabbafjfjdjlvldsuiueqwpomvdhgataewpvdihviasubababbba 5475 baaabba" );
	string::LinearString < char > input ( rawInput );

	ext::vector < bool > compressed = stringology::compression::AdaptiveIntegerArithmeticCompression::compress ( input );
	std::cout << "compressed = " << compressed << std::endl;
	string::LinearString < char > output = stringology::compression::AdaptiveIntegerArithmeticDecompression::decompress ( compressed, input.getAlphabet ( ) );

	std::cout << "original= " << input << std::endl << "decompressed = " << output << std::endl;
	std::cout << "compressed size = " << compressed.size ( ) << std::endl << "original_size = " << input.getContent ( ).size ( ) * 8 << std::endl;
	CPPUNIT_ASSERT ( input == output );
}

